
varying vec3 P;
varying vec3 N;
uniform sampler2D tex;
uniform float time;

void main(void)
{
  vec3 L = normalize(gl_LightSource[0].position.xyz - P);
  N = normalize(N);
  
  vec4 ambient = gl_FrontLightProduct[0].ambient;
  float dotNL = dot(N, L);//max(0.0, dot(N, L));
  vec4 diffuse = gl_FrontLightProduct[0].diffuse * max(0.0, dotNL);
	vec3 V = normalize(-P);
	vec3 H = normalize(L + V);
	float powNH = pow(max(dot(N, H), 0.0), gl_FrontMaterial.shininess);
	if(dotNL <= 0.0) powNH = 0.0;
	vec4 specular = gl_FrontLightProduct[0].specular * powNH;
  //eNX`̐F
  vec4 texColor;
  if(gl_TexCoord[0].t > gl_TexCoord[0].s + 1.0 - 0.02 * time) 
    texColor = vec4(1.0, 1.0, 1.0, 1.0);
  else
		texColor = texture2D(tex, gl_TexCoord[0].st);
	gl_FragColor = (ambient + diffuse) * texColor + specular;	
}
