//myGlsl.h

GLuint vertexShader, fragmentShader;
//shader fileǂݍ݃RpC
void readShaderCompile(GLuint shader, const char *file)
{
  FILE *fp;
  char *buf;
  GLsizei size, len;
  GLint compiled;
  
  // t@CJ
  fp = fopen(file, "rb");
  if(!fp) printf("t@CJƂł܂ %s\n", file);
  
  //t@C̖Ɉړ݈ʒu𓾂 
  fseek(fp, 0, SEEK_END);
  size = ftell(fp);//t@CTCY擾
  
  // t@CTCỸm 
  buf = (GLchar *)malloc(size);
  if (buf == NULL) {
    printf("mۂł܂ł \n");
  }
  
  // t@C擪ǂݍ 
  fseek(fp, 0, SEEK_SET);
  fread(buf, 1, size, fp);
  //VF[_IuWFNgɃvOZbg 
  glShaderSource(shader, 1, (const GLchar **)&buf, &size);
  //VF[_ǂݍݗ̈̉ 
  free(buf);
  fclose(fp);

  // VF[_̃RpC 
  glCompileShader(shader);
  glGetShaderiv( shader, GL_COMPILE_STATUS, &compiled );

  if ( compiled == GL_FALSE ) 
  {
	  printf( "RpCł܂ł!!: %s \n ", file);
	  glGetProgramiv( shader, GL_INFO_LOG_LENGTH, &size );
	  if ( size > 0 ) 
	  {
		  buf = (char *)malloc(size);
		  glGetShaderInfoLog( shader, size, &len, buf);
		  printf(buf);
		  free(buf);
	  }
  }
}

//N
void link( GLuint prog )
{
  GLsizei	size, len;
  GLint linked;
  char *infoLog ;

  glLinkProgram( prog );

  glGetProgramiv( prog, GL_LINK_STATUS, &linked );

  if ( linked == GL_FALSE ) 
  {
		printf("Nł܂ł!! \n");
	  	
		glGetProgramiv( prog, GL_INFO_LOG_LENGTH, &size );
		if ( size > 0 ) 
		{
			infoLog = (char *)malloc(size);
			glGetProgramInfoLog( prog, size, &len, infoLog );
			printf(infoLog);
			free(infoLog);
		}
  }
}

void initGlsl(GLuint *program, const char *vertexFile)
{
  //glew̏
  GLenum err = glewInit();
  if (err != GLEW_OK)
  {
	  printf("Error: %s\n", glewGetErrorString(err));
  }
  // GPU,OpenGL
  printf("VENDOR= %s \n", glGetString(GL_VENDOR));
  printf("GPU= %s \n", glGetString(GL_RENDERER));
  printf("OpenGL= %s \n", glGetString(GL_VERSION));
  printf("GLSL= %s \n", glGetString(GL_SHADING_LANGUAGE_VERSION));
  //VF[_[IuWFNg̍쐬
  vertexShader = glCreateShader(GL_VERTEX_SHADER);
  //VF[_[̓ǂݍ݂ƃRpC
  readShaderCompile(vertexShader, vertexFile);

  // VF[_vO̍쐬 
  *program = glCreateProgram();

  // VF[_IuWFNgVF[_vOɊ֘At
  glAttachShader(*program, vertexShader);

  // VF[_IuWFNg̍폜 
  glDeleteShader(vertexShader);

  // VF[_vÕN 
  link(*program);
}


void initGlsl(GLuint *program, const char *vertexFile, const char *fragmentFile)
{
  //glew̏
  GLenum err = glewInit();
  if (err != GLEW_OK)
  {
	  printf("Error: %s\n", glewGetErrorString(err));
  }
  // GPU,OpenGL
  printf("VENDOR= %s \n", glGetString(GL_VENDOR));
  printf("GPU= %s \n", glGetString(GL_RENDERER));
  printf("OpenGL= %s \n", glGetString(GL_VERSION));
  printf("GLSL= %s \n", glGetString(GL_SHADING_LANGUAGE_VERSION));
  //VF[_[IuWFNg̍쐬
  vertexShader = glCreateShader(GL_VERTEX_SHADER);
  fragmentShader = glCreateShader(GL_FRAGMENT_SHADER);
  //VF[_[̓ǂݍ݂ƃRpC
  readShaderCompile(vertexShader, vertexFile);
  readShaderCompile(fragmentShader, fragmentFile);

  // vOIuWFNg̍쐬 
  *program = glCreateProgram();

  // VF[_IuWFNgVF[_vOɊ֘At
  glAttachShader(*program, vertexShader);
  glAttachShader(*program, fragmentShader);

  // VF[_IuWFNg̍폜 
  glDeleteShader(vertexShader);
  glDeleteShader(fragmentShader);
  // VF[_vÕN 
  link(*program);
}


